// forceCollisionsBruteSphere.h
// By Joseph K Aicher, Summer 2014 with Professor Russell M Taylor II

#include "genericForce.h"
#include "chromoTypes.h"

#ifndef FORCECOLLISIONSBRUTESPHERE_H
#define FORCECOLLISIONSBRUTESPHERE_H

class forceCollisionsBruteSphere : public genericForce
{
protected :
    // details about the simulation
    CS_REAL collisionConstant;

    // openCL details
    cl_kernel clKernelCollision;
    size_t clKernelCollisionGlobalSize;
    cl_kernel clKernelCollisionJacobian;
    size_t clKernelCollisionJacobianGlobalSize;
    cl_mem clMassRadius;

public :
    // constructor
    forceCollisionsBruteSphere (
        std::string sim_CLdir, // the path of directory with openCL source
        cl_context sim_context, // openCL context to use
        cl_command_queue sim_queue, // openCL queue to use
        cl_ulong sim_numParticles, // number of particles in the simulation
        cl_ulong sim_totalMaxInteractions, // total maximum number of interactions (per particle) in Jacobian
        cl_device_id sim_deviceId, // the deviceId we are running on
        cl_mem sim_clPosition, // the positions
        CS_REAL * sim_MassRadius, // the mass radius information
        CS_REAL collisionSpringConstant
        );

    // destructor
    virtual ~forceCollisionsBruteSphere ( );

    // updates clForce with the collision forces
    virtual void calculateForce ( );

    // updates both clForce and clJacobian
    virtual void calculateForceAndJacobian ( );

    // gets the name of the force
    virtual const char * getName ( );
};





#endif