// forceMassDamping.cl
// OpenCL file for forceMassDamping
// By Joseph K Aicher, Summer 2014 with Professor Russell M Taylor II

#include <chromoTypes.cl>

__kernel void calculateDragForce( // calculates the drag force on each particle
    __global CS_REAL * drag, // the drag coefficients
    __global CS_REAL3 * velocity, // the velocity of the particles
    __global CS_REAL3 * fDamping, // the damping force (output)
    const ulong numParticles // the number of particles in the simulation
    )
{
    ulong ndx = get_global_id(0);

    if (ndx >= numParticles) {
        return;
    }

    // calculating the force on particle ndx is pretty simple
    fDamping[ndx] = - drag[ndx] * velocity[ndx];
}